#!/usr/bin/perl
#
#OPT_ENTDATA v1.1 Release by FragBait0, tlevi@tpg.com.au
#
#**********************************************************************************
#Feel free to add to or borrow from this code.
#If your adding to then please, tell me about it and we can keep it all together.
#If your borrowing then you can tell me about it with an email..
#The rest of you will do what you want anyway so without further avail...
#**********************************************************************************

$version='1.1 Release';

#Init global variables
use integer;
my $help=1;
my $logstuff=1;
my $verbose=0;
my $delbackup=0;
my $nolinemod=0;
my $nomiscents=0;
my $nolights=0;
my $nostrip=0;
my $logfile=0;
my $simplify=0;
my $noscrspam=0;
my $nofixpaths=0;
my $printno=0;
my $setting=0;
my $stripelms;
my $replaceamt;
my $filelines=0;
my $ripent=0;
my $ripentpath=0;
my $texdata=0;
my $lightdata=0;
my $noorigins=0;
my $chart=0;
my $noinfo=0;
my $dev=0;
my $runfrom='';
my $printbuffer='';
my $ripentexport='';
my @filecontents;
my @propertylist;
my @propertylistspecial;
my @propertyListRegExp;
my @propertyListSpecialRegExp;

# Set Global Variables
for ($i=0; $i<=$#ARGV; $i++){
 if ($ARGV[$i] =~ m/-ripent/){$ripent=1;}
 elsif ($ARGV[$i] =~ m/-verbose/) {$verbose=1;}
 elsif ($ARGV[$i] =~ m/-setting/){$setting=$ARGV[$i+1];}
 elsif ($ARGV[$i] =~ m/-simplify/){$simplify=1;}
 elsif ($ARGV[$i] =~ m/-nofixpaths/){$nofixpaths=1;}
 elsif ($ARGV[$i] =~ m/-delbackup/) {$delbackup=1;}
 elsif ($ARGV[$i] =~ m/-nolinemod/) {$nolinemod=1;}
 elsif ($ARGV[$i] =~ m/-nomiscents/) {$nomiscents=1;}
 elsif ($ARGV[$i] =~ m/-nolights/) {$nolights=1;}
 elsif ($ARGV[$i] =~ m/-nostrip/){$nostrip=1;}
 elsif ($ARGV[$i] =~ m/-nolog/){$logstuff=0;}
 elsif ($ARGV[$i] =~ m/-noscrspam/){$noscrspam=1;}
 elsif ($ARGV[$i] =~ m/-texdata/){$texdata=$ARGV[$i+1];}
 elsif ($ARGV[$i] =~ m/-lightdata/){$lightdata=$ARGV[$i+1];}
 elsif ($ARGV[$i] =~ m/-chart/){$chart=1;}
 elsif ($ARGV[$i] =~ m/-noinfo/){$noinfo=1;}
 elsif ($ARGV[$i] =~ m/-noorigins/){$noorigins=1;}
 elsif ($ARGV[$i] =~ m/-dev/){$dev++;}
}

#Immediate pipes - we do this so user can see status properly.
$|=1;

#directory of script
$_=$0;
s/opt_entdata\..*//;
$runfrom=$_;

sub printLog;

sub getEntStart{
 my $loop=1;
 my $i=$_[0];
 $return=0;
 unless ($filecontents[$i] =~ m/{/){
  while ($loop){
   if ($filecontents[$i] =~ m/{/){$return=$i;$loop=0;}
   elsif ($dev and $i<0){
    printLog "WARNING: not found entity start from $_[0] @ line $i, $filecontents[$i]";
    printLog $filecontents[$i];
    $i--;
   }
   else{$i--;}
   if ($i<0){$loop=0;$return=undef;}
  }
 }
 else{$return=$i;}
 return $return;
};
sub getEntEnd{
 my $loop=1;
 my $i=$_[0];
 $return=0;
 unless ($filecontents[$i] =~ m/}/){
  while ($loop){
   if ($filecontents[$i] =~ m/}/){$return=$i;$loop=0;}
   elsif ($dev and $i>$#filecontents){
    printLog "WARNING: not found entity end from $_[0] @ line $i, $filecontents[$i]";
    $i++;
   }
   else{$i++;}
   if ($i>$#filecontents){$loop=0;$return=undef;}
  }
 }
 else{$return=$i;}
 return $return;
};
sub getLightEntStart{
 my $loop=1;
 my $i=shift;
 $return=undef;
 $_=$light[$i];
 while ($loop){
  $_=$light[$i];
  if (defined and m/{/){$return=$i;$loop=0;}
  else{$i--;}
  if ($i<0){$loop=0;}
 }
 return $return;
};
sub getLightEntEnd{
 my $loop=1;
 my $i=shift;
 $return=undef;
 $_=$light[$i];
 while ($loop){
  $_=$light[$i];
  if (defined and m/}/){$return=$i;$loop=0;}
  else{$i++;}
  if ($i>$#light){$loop=0;}
 }
 return $return;
};

if ($ARGV[0]){ # all this boils down to the last line: if a -? is found then the user is trying to get help
 if ('/h' eq $ARGV[0]){$ARGV[0]='-?';} # or dosent know what they are doing.. help em anyway :)
 if ('-h' eq $ARGV[0]){$ARGV[0]='-?';}
 if ('h' eq $ARGV[0]){$ARGV[0]='-?';}
 if ('?' eq $ARGV[0]){$ARGV[0]='-?';}
 if ('/?' eq $ARGV[0]){$ARGV[0]='-?';}
 unless ('-?' eq $ARGV[0]) {$help=0;}
}

#print to log and screen
sub printLog{
 unless ($noscrspam){print STDOUT @_;}
 if ($logstuff){print LOG @_;}
};
sub printLogOnly{
 if ($logstuff){print LOG @_;}
};

# Setup our files.
$file=$ARGV[0];
if ($file =~ (m/\.bsp/ or m/\.ent/)){
 foreach(0..3){
  chop $file;
 }
}
$filetmp="$file\.tmp";
$ent="$file\.ent";
$bsp="$file\.bsp";
$logfile="$file\.log";

#Check log file exists, open it and disable logging if it dosent exist.
if ((-e $logfile) and ($logstuff==1)){
 open LOG,'>>',$logfile;
}
else {$logstuff=0;}

#BEGIN SETTINGS LOAD
my @settings;
unless ($setting eq '0'){
 $setting =~ s/\..*//;
}
else{
 $setting="setting_default";
}
if (open FILE,'<',"$runfrom$setting\.db"){
 if ($verbose){
  $printbuffer=($printbuffer."Setting from: $runfrom$setting\.db\n");
 }
 @settings=<FILE>;
 close FILE;
 foreach (@settings){
  if (m/\/\// or m/#/ or ($_ eq "\n")){ #double backslash or hashed lines are comments
   $_='';				#\n lines are ignored also.
  }					#We don't bother to remove them because it's not worth the time.
 }
}
undef $setting;
#END SETTINGS LOAD

#Make a temporary array which tells us what to import only - no RIPENT line etc
my @tempsetting=@settings;
foreach (@tempsetting){
 unless (m/^include/){
  $_='';
 }
 else{
  chomp;
  s/include //;
 }
}

#GET RIPENT SETTING
foreach (@settings){
 if ($ripent==1){
  if (m/RIPENT/){
   s/RIPENT, //;
   chomp;
   $ripentpath=$_;
   unless (m/:/){ #unless its a full path hack one! Because we have to do something..
    $ripentpath=$runfrom.$ripentpath;
   }
  }
 }
}

#Open database and load it to @settingfile
open FILE,'<',"${runfrom}\\opt_entdata\.db";
@settingfile=<FILE>;
close FILE;
foreach (@settingfile){
 chomp;
}

#Parse @settingfile and remove any sections not permitted by @tempsetting
#Place allowed items in @settingtemp
foreach (@tempsetting){
 if (length $_ > 0){ #is not a null string
  my $allowed=0;
  my $i=1; #$allowed must be true if something found and maybe on line 0
  foreach $temp (@settingfile){
   if (!($allowed) and ($temp eq $_)){
    $allowed=$i;
   }
   $i++;
  }
  undef $i;
  my $endplace=0;
  if ($allowed){
   my $i=$allowed;
   #my $copy=$_;
   my $loop=1;
   while ($loop){
    #$_=$settingfile[$i];
    if (length $settingfile[$i] == 0){
     $endplace=$i;
     $i=0;
     $loop=0;
    }
    $i++;
    if ($i>$#settingfile){$loop=0;}
   }
   #$_=$copy;
   #undef $copy;
   undef $i;
   undef $loop;
  }
  if (($endplace>0) and ($allowed>0)){
   push @settingtemp, @settingfile[($allowed-1)..($endplace-1)];
  }
  undef $allowed;
 }
}

#clear out some of the memory we wasted BADLY there.
undef @settings;
undef $setting;
undef @settingfile;
undef @tempsetting;

if ($ripent==1){
 unless ($ripentpath eq ''){$ripentexport="\"$ripentpath\"";}
 else{$ripentexport='ripent.exe';}
 if ($texdata > 0){$ripentexport=$ripentexport.' -texdata '.$texdata;}
 if ($lightdata > 0){$ripentexport=$ripentexport.' -lightdata '.$lightdata;}
 if ($chart){$ripentexport=$ripentexport.' -chart';}
 if ($noinfo){$ripentexport=$ripentexport.' -noinfo';}
 $ripentexport=$ripentexport.' -export '.$bsp;
 system $ripentexport;
 $printbuffer=($printbuffer."Using ripent: $ripentexport\n");
 $_=$ripentexport;
 s/-export/-import/;
 $ripentimport=$_;
 $printbuffer=($printbuffer."Using ripent: $ripentimport\n");
 undef $ripentexport;
}

printLog "\nopt_entdata for HL1, $version by FragBait0,\n";
printLog "Submit detailed bug reports and suggestions to FragBait0: tlevi\@tpg.com.au.\n";
printLog "Parts based on code by Zoner.\n";
printLog "--- BEGIN opt_entdata ---\n\n";

if ($help==1){
 printLog "You must have asked for help or got something wrong!\n";
 printLog "Please refer to the readme.htm file.\n";
 printLog "\n---- END opt_entdata ----\n";
 exit;
}

#SORT FROM SETTINGS LOADED TO APPROPRIATE ARRAYS/SCALARS
#Modes are:
#0 - EOF / No appropiate setting found.
#1 - REPLACE x with x
#2 - PROPERTYLIST_SPECIAL
#3 - PROPERTYLIST is for standard property files.
#4 - REMOVE_ORIGINS is for entities the origin can be snipped from.
my $mode=0;
my @replaceThis;
my @replaceWithThis;
foreach(@settingtemp){
 if (m/IGNORE/){$mode=0;}
 elsif (m/REPLACE/){$mode=1;}
 elsif (m/PROPERTYLIST_SPECIAL/){$mode=2;}
 elsif (m/PROPERTYLIST/){$mode=3;}
 elsif (m/REMOVE_ORIGINS/){$mode=4;}
 elsif ($i==$#settingtemp){$mode=0;}
 else {
  if ($mode!=0){
   if ($mode==1){
    @temp = split /., /;
    push @replaceThis, $temp[0];
    push @replaceWithThis, $temp[1];
   }
   elsif ($mode==2){
    if (m/\(|\||\\|\.|\*|\+|\?|\)/){
     push @propertyListSpecialRegExp, $_;
    }
    else{
     push @propertylistspecial, $_;
    }
   }
   elsif ($mode==3){
    if (m/\(|\||\\|\.|\*|\+|\?|\)/){
     push @propertyListRegExp, $_;
    }
    else{
     push @propertylist, $_;
    }
   }
   elsif ($mode==4){
    push @origins, $_;
   }
  }
 }
}
undef $mode;
undef @settingtemp;

#Make sure we are *close* to the actual value with some FORs
$stripelms=$#propertylist+$#propertylistspecial+$#propertyListRegExp+$#propertyListSpecialRegExp;
for ($i=0; $i<=$#propertyListRegExp; $i++){
 $_=$propertyListRegExp[$i];
 my $beforelen=length;
 s/|//;
 my $afterlen=length;
 $stripelms+=$beforelen-$afterlen;
}
for ($i=0; $i<=$#propertyListSpecialRegExp; $i++){
 $_=$propertyListSpecialRegExp[$i];
 my $beforelen=length;
 s/|//;
 my $afterlen=length;
 $stripelms+=$beforelen-$afterlen;
}

$replaceamt=$#replaceThis;
unless ((defined $stripelms) and ($stripelms>0)){$stripelms=0;}
unless ((defined $replaceamt) and ($replaceamt>0)){$replaceamt=0;}

#Code is still here because it can be useful for debugging.
#This usually just spams people for no *really* good reason.
#unless ($noscrspam){
# printLog "Command line options: @ARGV\n";
# printLog "Options used: ";
# if ($verbose){printLog "Verbose ";}
# if ($dev){printLog "Developer ";}
# unless ($logstuff){printLog "No-log "}
# if ($delbackup){printLog "Delete-backup ";}
# if ($nolinemod){printLog "No-line-terminator-mod ";}
# if ($nomiscents){printLog "No-misc-entity-removal ";}
# if ($nolights){printLog "No-light-removal ";}
# if ($nostrip){printLog "No-property-stripping ";}
# if ($nofixpaths){printLog "No-path-fixing ";}
# if ($setting){printLog "Custom-settings ";}
# if ($simplify){printLog "Entity-name-simplify ";}
# if ($texdata>0){printLog "Texdata-of-$texdata ";}
# if ($lightdata>0){printLog "Lightdata-of-$lightdata ";}
# if ($ripent>0){printLog "Auto-run-ripent ";}
# if ($noorigins){printLog "No-origin-stripping ";}
# printLog "\n";
#}

if ($noscrspam and !($verbose)){printLogOnly "\n$printbuffer\n";}
else {printLog "\n$printbuffer\n";}

#Check file exists and give em a mouthful if it dosent.
unless (-e $ent){ 
 printLog "ERROR: Entdata file not found.\n";
 printLog "Please check the file exists and you got the options right.\n";
 printLog "Also be sure that ripents worked if you tried to use it.\n";
 printLog "You tried to open: $file\n";
 printLog "\n---- END opt_entdata ----\n";
 exit; 
}

if ($verbose==1){
 printLog "Reading file..";
 if ($printno==2){
  printLog "\n";
  $printno=0;
 }
 else{$printno++;}
}
open FILE,'<',$ent;
binmode FILE;
@filecontents=<FILE>;
$filelines=$.;
close FILE;

#Clean up the last line.
unless ($filecontents[-1] =~ m/}/){
 pop @filecontents;
}


# Begin remove thingys...

#Remove misc ents
unless ($nomiscents==1){
 if ($verbose==1){
  printLog "Removing unrequired entities..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 $i=0;
 $loop=1;
 while ($loop==1){
  $_ = $filecontents[$i];
  if (m/"classname" "(info_compile_parameters|info_texlights|info_null)"/){
   $firstelm=getEntStart($i);
   $lastelm=getEntEnd($i);
   $splicenum=($lastelm-$firstelm)+1;
   splice @filecontents, $firstelm, $splicenum;
   $i=$i-$splicenum;
  }
  else {$i++;}
  if ($i >= $#filecontents){
   $loop=0;
  }
 }
}

#Remove useless lights
#We don't $i-- in the for because not *every* line needs to be tested to find every light.
unless ($nolights==1){
 if ($verbose==1){
  printLog "Removing Lights..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 for ($i=0; $i<$#filecontents; $i++){
  if ($filecontents[$i] =~ m/"classname" "(light|light_spot|light_environment)"/){
   my $firstelm=getEntStart($i);
   my $lastelm=getEntEnd($i);
   my $splicenum=($lastelm-$firstelm)+1;
   my $nosplice=0;
   foreach(@filecontents[$firstelm..$lastelm]){
    if (m/"targetname" ".+"/){$nosplice=1;}
   }
   unless ($nosplice){
    splice @filecontents, $firstelm, $splicenum;
    $i=$firstelm-1;
   }
   elsif ($nosplice){
    $i=$lastelm+1;
   }
  }
 }
}

#Dynamic Light Optimisation
#Takes remaining lights and moves them to the @light, taking out crap as it goes.
#Don't ask me what crazy crap I was on when this was made.
#DO NOT PLAY WITH THIS...unless you really know what you're doing.
unless ($nolights==1){
 if ($verbose==1){
  printLog "Optimising Dynamic Lights..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 my $i=0;
 my $loop=1;
 my @light;
 while ($loop){
  $_=$filecontents[$i];
  if (m/"classname" "(light|light_spot)"/){
   my $firstelm=getEntStart($i);
   my $lastelm=getEntEnd($i);
   my @slice=@filecontents[$firstelm..$lastelm];
   my $slice_spot=1;
   while ($slice_spot>0){
    $slice_spot--;
    unless ($slice[$slice_spot] =~ m/({|}|"spawnflags"|"classname"|"targetname"|style|time)/){ #Keep stuff we need
     splice @slice, $slice_spot, 1;
    }
    else{$slice_spot++;}
    $slice_spot++;
    if ($slice_spot>$#slice){$slice_spot=0;}
   }
   undef $slice_spot;

   push @light, @slice;
   splice @filecontents, $firstelm, ($lastelm-$firstelm)+1;
   $i=$firstelm;
  }
  else{$i++;}
  if ($i>=$#filecontents){$loop=0;}
 }
 $i=0;
 my @lightlines;
 foreach(@light){
  if (m/"classname" "(light|light_spot)"/){push @lightlines, $i;}
  $i++;
 }
 $i=0;
 foreach(@lightlines){
  my $firstelm=getLightEntStart($_);
  my $lastelm=getLightEntEnd($_);
  if ((defined $firstelm) and (defined $lastelm)){
   my @currslice=@light[$firstelm..$lastelm];
   my $same=0;
   foreach $temp (@lightlines){
    if ($temp != $_){
     my $firstelm2=getLightEntStart($temp);
     my $lastelm2=getLightEntEnd($temp);
     my @workingslice=@light[$firstelm2..$lastelm2];
     if ($#workingslice==$#currslice){
      my $same2=1;
      foreach(0..$#workingslice){
       unless($workingslice[$_] eq $currslice[$_]){$same2=0;}
      }
      if ($same2==1){$same=1;}
     }
    }
   }
  }
  if ((defined $same) and ($same==1)){
   splice @light, $firstelm, $#currslice;
   my $k=0;
   foreach $temp (@lightlines){
    if ($k > $i){
     $temp-=($#currslice+1);
    }
    $k++;
   }
  }
 }
 push @filecontents, @light;
}


#stripnulents
unless ($nostrip==1){
 if ($verbose==1){
  unless ($printno==0){printLog "\n";}
  printLog "Striping ent properties..";
  $printno=0;
 }
 my $linecounter=0;
 my $plus=200;

 #Set a reasonable $plus for different file sizes.
 if ($#filecontents>=6000){$plus=1000;}
 elsif ($#filecontents>=3000){$plus=500;}
 elsif ($#filecontents>=1200){$plus=200;}
 elsif ($#filecontents<=550){$plus=50;}
 elsif ($#filecontents<=1200){$plus=100;}

 #This is the core of it.
 #Go through each line of @filecontents and check
 #it dosen't match anything in @propertylist or @propertylistspecial
 for (my $i=0;$i<=$#filecontents;$i++){
  unless ($filecontents[$i] eq ("{\n" or "}\n")){
   my $k=0;
   for ($k=0; $k<=$#propertylist; $k++){
    if (($filecontents[$i] eq qq("$propertylist[$k]" "0"\n)) || (($k<=$#propertylistspecial) and ($filecontents[$i] eq qq($propertylistspecial[$k]\n)))){
     splice @filecontents, $i, 1; $i--;
     $k=$#propertylist+1;
    }
   }
   unless ($k==($#propertylist+2)){
    for ($k=0; $k<=$#propertyListRegExp; $k++){
     if ($filecontents[$i] =~ m/"$propertyListRegExp[$k]" "0"/ || ($k<=$#propertyListSpecialRegExp and $filecontents[$i] =~ m/$propertyListSpecialRegExp[$k]/)){
      splice @filecontents, $i, 1; $i--;
      $k=$#propertylist+2;
     }
    }
   }
  }
  if ($i eq ($linecounter+$plus)){
   $linecounter+=$plus;
   printLog "$linecounter..";
  }
 }
 
 shift @filecontents;
 unshift @filecontents, (("{\n"),('"classname" "worldspawn"'."\n"));
 #HACK - that was to add the worldspawn. They are removed by stripnulents.
 my $finallines=$#filecontents;
 printLog "$finallines..";
 printLog "Done.\n";
}


#A quick hack to fix bad paths to models, sprites etc...also clean wad paths.
#No-go for *nix :(
unless ($nofixpaths==1){
 if ($verbose==1){
  printLog "Fixing bad paths..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 foreach (@filecontents){
  if (defined){
   unless (m/"wad"/){
    s/\\/\//g; # replace backslash with forwardslash.
    s/(".*" ").+?\/models/$1models/i; #models
    s/(".*" ").+?\/sprites/$1sprites/i; #sprites
    s/(".*" ").+?\/sound\//$1/i; #sound - dosen't need /sound dir
    s/(".*" ").+?\/aurora/$1aurora/i; #aurora - spirit particle files
   }
  }
 }
 $i=0;
 $iLine=0;
 foreach (@filecontents){
  if (defined and m/"wad".*\w:\\/){ #Very windows-ish. :(
   $iLine=$i;
  }
  $i++;
 }
 unless ($iLine==0){
  $newWad='"wad" "';
  $_=$filecontents[$iLine];
  chop;
  chop;
  s/\"wad\" \"//;
  @tmpWad = split /\;/;
  foreach (@tmpWad){
   m/\w:\\.*\\(.*)\.wad/;
   $newWad=($newWad.$1.';');
  }
  $newWad=$newWad."\"\n";
  $filecontents[$iLine]=$newWad;
 }
}

#Removes trailing 0's from color values etc.
#New for 1.0 Release. No switch.
foreach (@filecontents){
 unless ($_ eq ("{\n"||"}\n")){
  s/(.*" ".*) 0 0"/$1"/; #Strip two 0s
  s/(.*" ".* .*) 0"/$1"/; #Strip one 0
 }
}

#Simplify. This finds targetnames and sets them to a letter (a-zzz) throughout the file.
if ($simplify==1){
 if ($verbose==1){
  printLog "Symplifying names..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 @newNameList=('a'..'z','aa'..'zz','aaa'..'zzz');

 my $rootLineCount=0;
 my $nc=0; #Names-used count
 for ($i=0; ($i<$#filecontents)&&($nc<999); $i++){ #($nc<999) - check we don't go over the $#newNameList.
  if ($filecontents[$i] =~ m/"targetname" "(.+)"/){
   my $temp=$1;
   my $goahead=1;
   @entity=@filecontents[getEntStart($rootLineCount)..getEntEnd($rootLineCount)];
   for ($k=0; $k<$#entity; $k++){
    if ($entity[$k] =~ m/"classname" "(info_landmark|trigger_(transition|changelevel))"/){
     $goahead=0;
    }
   }
   if ($goahead==1){
    foreach (@filecontents){ #the (\+?|\-?|~?|&?) bits are for the extra trigger options in SoHL.
     unless ($_ eq ("{\n"||"}\n")){
      if (m/".+" "(\+?|\-?|~?|&?)$temp"/){
       s/"(.+)" "(\+?|\-?|~?|&?)$temp"/"$1" "$2$newNameList[$nc]"/;
      }
      elsif (m/"(\+?|\-?|~?|&?)$temp" ".+"/){
       s/"(\+?|\-?|~?|&?)$temp" "(.+)"/"$1$newNameList[$nc]" "$2"/;
      }
      elsif (m/"(\+?|\-?|~?|&?)$temp#[0-9]" ".+"/){
       s/"(\+?|\-?|~?|&?)$temp#([0-9])" "(.+)"/"$1$newNameList[$nc]#$2" "$3"/;
      }
      elsif (m/".+" ".+\($temp\)"/){ #SoHL
       s/"(.+)" "(.+)\($temp\)"/"$1" "$2\($newNameList[$nc]\)"/;
      }
     }
    }
    $nc++;
   }
  }
  $rootLineCount++;
 }
 undef $rootLineCount;
 undef $nc;
}

#Origin remover
unless ($noorigins==1){
 if ($verbose==1){
  printLog "Removing origins..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 my @removeat=undef;
 my $loop=1;
 my $i=0;
 foreach $temp (@origins){
  while ($loop){
   $_=$filecontents[$i]; 
   if ((defined $temp and $_) and m/"classname" "$temp"/){
    my $firstelm=getEntStart($i);
    my $lastelm=getEntEnd($i);
    my $splice=0;
    my $counter=0;
    my $add_to_offset=0;
    foreach (@filecontents[$firstelm..$lastelm]){
     if (m/"origin"/){$splice=1;$add_to_offset=$counter;}
     $counter++;
    }
    undef $counter;
    if ($splice){
     splice @filecontents, ($firstelm+$add_to_offset), 1;
    }
    else{$i++;}
   }
   else{$i++;}
   if($i>=$#filecontents){$loop=0;}
  }
 }
 undef $temp;
}


#Replacer. Takes contents of replaceThis and replaceWithThis and applies them to @filecontents.
if ($#replaceThis>0){
 if ($verbose==1){
  printLog "Replacing strings..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 foreach $replaceIn (@filecontents) {
  $i=0;
  foreach (0..$#replaceThis){
   $_=$replaceIn;
   s/"$replaceThis[$i]"/"$replaceWithThis[$i]"/;
   $i++;
  }
 }
}

#Finish by setting line terminators to unix-style...
unless ($nolinemod==1){
 if ($verbose==1){
  printLog "Modding Line Terminator..";
  if ($printno==2){
   printLog "\n";
   $printno=0;
  }
  else{$printno++;}
 }
 foreach (@filecontents){
  if (defined){
   s/\n/\r/;
  }
 }
}

#Write, clean up, exit.
if ($verbose==1){
 printLog "Writing file..";
 if ($printno==2){
  printLog "\n";
  $printno=0;
 }
 else{$printno++;}
}
$|=0;
open OUTFILE,'>',$filetmp;
foreach (@filecontents){
 if (defined){
  print OUTFILE;
 }
}
close OUTFILE;
$|=1;

if ($verbose==1) {
 printLog "Renaming files..";
 if ($printno==2){
  printLog "\n";
  $printno=0;
 }
 else{$printno++;}
} 
rename($ent, "$ent.bak") or die "Error: can't rename $ent to $ent.bak: $!";
rename($filetmp, $ent) or die "Error: can't rename $filetmp to $ent: $!";

#get filesizes before deleting one.
my $before=(-s "$ent.bak");
my $after=(-s $ent);
my $difference=($after-$before);
no integer;
my $beforekb=int(($before/1024)*10)*0.1;
my $afterkb=int(($after/1024)*10)*0.1;
my $diffkb=int(($difference/1024)*10)*0.1;
my $percent=($after/$before)*100;
$percent=int($percent*10);
$percent=$percent*0.1;
use integer;

if ($delbackup){
 printLog "Deleting Backup..";
 if ($printno==2){
  printLog "\n";
  $printno=0;
 }
 else{$printno++;}
 unlink "$ent.bak";
}

unless ($printno==0){
 printLog "\n";
}

unless ($noscrspam==1){
 printLog "\n$filelines lines in input file,\n";
 printLog "$#filecontents lines in output file,\n";
 unless ($nostrip==1){
  printLog "Striped a list of $stripelms unique properties, replaced $replaceamt things.\n";
 }
 printLog "$beforekb kB reduced to $afterkb kB.\n";
 printLog "Difference of $diffkb kB, roughly $percent% of original size.\n";
}
else {
 printLogOnly "\n$filelines lines in input file,\n";
 printLogOnly "$#filecontents lines in output file,\n";
 unless ($nostrip==1){
  printLogOnly "Striped a list of $stripelms unique properties, replaced $replaceamt things.\n";
 }
 printLogOnly "$beforekb kB reduced to $afterkb kB.\n";
 printLogOnly "Difference of $diffkb kB, $percent% of original size.\n";
}
printLog "\n---- END opt_entdata ----\n\n";

#Run ripents outside.
if ($ripent==1){
 system $ripentimport;
 if($delbackup){unlink $ent;}
}

exit;
